//! Sync utils
use super::*;
use std::sync::Arc;
use std::sync::atomic::AtomicBool;
use std::mem::MaybeUninit;
use std::cell::UnsafeCell;

// This was a failure. Just use `tokio::sync::oneshot`...

/*
#[derive(Debug)]
struct SharedInitialiser<T>
{
    data: Arc<(UnsafeCell<MaybeUninit<T>>, AtomicBool)>,
}

impl<T> Clone for SharedInitialiser<T>
{
    #[inline] fn clone(&self) -> Self {
	Self { data: Arc::clone(&self.data) }
    }
}

#[derive(Debug)]
pub struct SharedInitRx<T>(SharedInitialiser<T>);

/// Permits initialising across a thread.
// Do we even need this? No.. We can just use `tokio::sync::oneshot`....
#[derive(Debug)]
pub struct SharedInitTx<T>(SharedInitialiser<T>);

impl<T> SharedInitTx<T>
{
    /// Consume this instance and initialise it.
    ///
    /// # Panics
    /// If there is already a value set (this should never happen).
    pub fn initialise(self, value: T)
    {
	todo!()
    }
}

impl<T> SharedInitRx<T>
{
    /// Create a sender and receiver pair
    pub fn pair() -> (SharedInitTx<T>, Self)
    {
	let this = Self::new();
	(this.create_tx(), this)
    }
    /// Create a new, uninitialised receiver.
    #[inline] fn new() -> Self
    {
	Self(SharedInitialiser{data: Arc::new((UnsafeCell::new(MaybeUninit::uninit()), false.into()))})
    }
    /// Create an initialiser
    ///
    /// # Panics (debug)
    /// If an initialiser already exists
    #[inline] fn create_tx(&self) -> SharedInitTx<T>
    {
	debug_assert_eq!(Arc::strong_count(&self.0.data), 1, "Sender already exists");

	SharedInitTx(self.0.clone())
    }

    /// Checks if there is a value present, or if it is possible for a value to be present.
    pub fn is_pending(&self) -> bool
    {
	todo!("Either self.0.data.1 == true, OR, strong_count() == 2")
    }

    /// Has a value already been set
    pub fn has_value(&self) -> bool
    {
	todo!("self.0.data.1 == true")
    }
    
    /// Try to consume into the initialised value.
    pub fn try_into_value(self) -> Result<T, Self>
    {
	todo!()
    }

    /// Consume into the initialised value
    ///
    /// # Panics
    /// If the value hasn't been initialised
    #[inline] pub fn into_value(self) -> T
    {
	self.try_into_value().map_err(|_| "No initialised value present").unwrap()
    }

    /// Does this receiver have an initialser that hasn't yet produced a value?
    pub fn has_initialiser(&self) -> bool
    {
	Arc::strong_count(&self.0.data) == 2
    }
}
*/
